package iterativeSuche;

public class IterativeSearch {

	public static int search(int number[], int min, int max, int numToFind) {
		int index = min + (max - min) / 2;
		System.out.println("min="+min+"  max="+max);
		if ((min+1)==max) { // number not found
			return index;
		}
		if (number[index] > numToFind) { // numToFind is smaller
			max = index;
			return search(number, min, max, numToFind);
		} else if (number[index] < numToFind) {// num to find is bigger
			min = index;
			return search(number, min, max, numToFind);
		} else { // found number
			return index;
		}
	}

	public static void main(String[] args) {
		int numbers[] = new int[100];
		// --- generate random numbers
		for (int t=0;t<100;t++) {
			numbers[t] = (int)(100*Math.random());
		}
		// --- sort numbers
		for (int t=0;t<100-1; t++) {
			if (numbers[t]>numbers[t+1]) {
				int help     = numbers[t];
				numbers[t]   = numbers[t+1];
				numbers[t+1] = help;
				t=-1;
			}
		}
		// --- print numbers
		for (int t=0;t<100;t++) {
			System.out.println("numbers["+t+"]="+numbers[t]);
		}
		// --- search iteratively
		System.out.println("Next element found at " + search(numbers,0,100,33));
	}
}
